Skip to content

# Module `liteyuki.bot.lifespan` ​

Copyright (C) 2020-2024 LiteyukiStudio. All Rights Reserved

@Time : 2024/7/23 下午8:24 @Author : snowykami @Email : snowykami@outlook.com @File : lifespan.py @Software: PyCharm

### var `SYNC_LIFESPAN_FUNC` ​

- Description: 同步生命周期函数

- Type: `TypeAlias`

- Default: `Callable[[], Any]`

### var `ASYNC_LIFESPAN_FUNC` ​

- Description: 异步生命周期函数

- Type: `TypeAlias`

- Default: `Callable[[], Awaitable[Any]]`

### var `LIFESPAN_FUNC` ​

- Description: 生命周期函数

- Type: `TypeAlias`

- Default: `SYNC_LIFESPAN_FUNC | ASYNC_LIFESPAN_FUNC`

### var `SYNC_PROCESS_LIFESPAN_FUNC` ​

- Description: 同步进程生命周期函数

- Type: `TypeAlias`

- Default: `Callable[[str], Any]`

### var `ASYNC_PROCESS_LIFESPAN_FUNC` ​

- Description: 异步进程生命周期函数

- Type: `TypeAlias`

- Default: `Callable[[str], Awaitable[Any]]`

### var `PROCESS_LIFESPAN_FUNC` ​

- Description: 进程函数

- Type: `TypeAlias`

- Default: `SYNC_PROCESS_LIFESPAN_FUNC | ASYNC_PROCESS_LIFESPAN_FUNC`

### class `Lifespan` ​

#### func `__init__(self) -> None` ​

Description: 轻雪生命周期管理，启动、停止、重启

Source code or View on GitHub
python

    def __init__(self) -> None:
        self.life_flag: int = 0
        self._before_start_funcs: list[LIFESPAN_FUNC] = []
        self._after_start_funcs: list[LIFESPAN_FUNC] = []
        self._before_process_shutdown_funcs: list[PROCESS_LIFESPAN_FUNC] = []
        self._after_shutdown_funcs: list[LIFESPAN_FUNC] = []
        self._before_process_restart_funcs: list[PROCESS_LIFESPAN_FUNC] = []
        self._after_restart_funcs: list[LIFESPAN_FUNC] = []

`@staticmethod`

#### async func `run_funcs(funcs: Sequence[LIFESPAN_FUNC | PROCESS_LIFESPAN_FUNC], *args, **kwargs) -> None` ​

Description: 并发运行异步函数

Arguments:

> - funcs (`Sequence`[`ASYNC_LIFESPAN_FUNC` | `PROCESS_LIFESPAN_FUNC`]): 函数列表

Source code or View on GitHub
python

    @staticmethod
    async def run_funcs(funcs: Sequence[LIFESPAN_FUNC | PROCESS_LIFESPAN_FUNC], *args, **kwargs) -> None:
        tasks = [func(*args, **kwargs) if is_coroutine_callable(func) else async_wrapper(func)(*args, **kwargs) for func in funcs]
        await asyncio.gather(*tasks)

#### func `on_before_start(self, func: LIFESPAN_FUNC) -> LIFESPAN_FUNC` ​

Description: 注册启动时的函数

Arguments:

> - func (`LIFESPAN_FUNC`): 生命周期函数

Return: `LIFESPAN_FUNC`: 生命周期函数

Source code or View on GitHub
python

    def on_before_start(self, func: LIFESPAN_FUNC) -> LIFESPAN_FUNC:
        self._before_start_funcs.append(func)
        return func

#### func `on_after_start(self, func: LIFESPAN_FUNC) -> LIFESPAN_FUNC` ​

Description: 注册启动时的函数

Arguments:

> - func (`LIFESPAN_FUNC`): 生命周期函数

Return: `LIFESPAN_FUNC`: 生命周期函数

Source code or View on GitHub
python

    def on_after_start(self, func: LIFESPAN_FUNC) -> LIFESPAN_FUNC:
        self._after_start_funcs.append(func)
        return func

#### func `on_before_process_shutdown(self, func: PROCESS_LIFESPAN_FUNC) -> PROCESS_LIFESPAN_FUNC` ​

Description: 注册进程停止前的函数

Arguments:

> - func (`PROCESS_LIFESPAN_FUNC`): 进程生命周期函数

Return: `PROCESS_LIFESPAN_FUNC`: 进程生命周期函数

Source code or View on GitHub
python

    def on_before_process_shutdown(self, func: PROCESS_LIFESPAN_FUNC) -> PROCESS_LIFESPAN_FUNC:
        self._before_process_shutdown_funcs.append(func)
        return func

#### func `on_after_shutdown(self, func: LIFESPAN_FUNC) -> LIFESPAN_FUNC` ​

Description: 注册停止后的函数

Arguments:

> - func (`LIFESPAN_FUNC`): 生命周期函数

Return: `LIFESPAN_FUNC`: 生命周期函数

Source code or View on GitHub
python

    def on_after_shutdown(self, func: LIFESPAN_FUNC) -> LIFESPAN_FUNC:
        self._after_shutdown_funcs.append(func)
        return func

#### func `on_before_process_restart(self, func: PROCESS_LIFESPAN_FUNC) -> PROCESS_LIFESPAN_FUNC` ​

Description: 注册进程重启前的函数

Arguments:

> - func (`PROCESS_LIFESPAN_FUNC`): 进程生命周期函数

Return: `PROCESS_LIFESPAN_FUNC`: 进程生命周期函数

Source code or View on GitHub
python

    def on_before_process_restart(self, func: PROCESS_LIFESPAN_FUNC) -> PROCESS_LIFESPAN_FUNC:
        self._before_process_restart_funcs.append(func)
        return func

#### func `on_after_restart(self, func: LIFESPAN_FUNC) -> LIFESPAN_FUNC` ​

Description: 注册重启后的函数

Arguments:

> - func (`LIFESPAN_FUNC`): 生命周期函数

Return: `LIFESPAN_FUNC`: 生命周期函数

Source code or View on GitHub
python

    def on_after_restart(self, func: LIFESPAN_FUNC) -> LIFESPAN_FUNC:
        self._after_restart_funcs.append(func)
        return func

#### async func `before_start(self) -> None` ​

Description: 启动前钩子

Source code or View on GitHub
python

    async def before_start(self) -> None:
        logger.debug('Running before_start functions')
        await self.run_funcs(self._before_start_funcs)

#### async func `after_start(self) -> None` ​

Description: 启动后钩子

Source code or View on GitHub
python

    async def after_start(self) -> None:
        logger.debug('Running after_start functions')
        await self.run_funcs(self._after_start_funcs)

#### async func `before_process_shutdown(self, *args, **kwargs) -> None` ​

Description: 停止前钩子

Source code or View on GitHub
python

    async def before_process_shutdown(self, *args, **kwargs) -> None:
        logger.debug('Running before_shutdown functions')
        await self.run_funcs(self._before_process_shutdown_funcs, *args, **kwargs)

#### async func `after_shutdown(self) -> None` ​

Description: 停止后钩子 未实现

Source code or View on GitHub
python

    async def after_shutdown(self) -> None:
        logger.debug('Running after_shutdown functions')
        await self.run_funcs(self._after_shutdown_funcs)

#### async func `before_process_restart(self, *args, **kwargs) -> None` ​

Description: 重启前钩子

Source code or View on GitHub
python

    async def before_process_restart(self, *args, **kwargs) -> None:
        logger.debug('Running before_restart functions')
        await self.run_funcs(self._before_process_restart_funcs, *args, **kwargs)

#### async func `after_restart(self) -> None` ​

Description: 重启后钩子 未实现

Source code or View on GitHub
python

    async def after_restart(self) -> None:
        logger.debug('Running after_restart functions')
        await self.run_funcs(self._after_restart_funcs)